<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML3.2 EN">
<HTML>
<HEAD>
<META NAME="GENERATOR" CONTENT="DOCTEXT">
<TITLE>MatShellSetOperation</TITLE>
</HEAD>
<BODY BGCOLOR="FFFFFF">
<A NAME="MatShellSetOperation"><H1>MatShellSetOperation</H1></A>
Allows user to set a matrix operation for a shell matrix. 
<H3><FONT COLOR="#CC3333">Synopsis</FONT></H3>
<PRE>
#include "petscmat.h" 
PetscErrorCode PETSCMAT_DLLEXPORT MatShellSetOperation(Mat mat,MatOperation op,void (*f)(void))
</PRE>
Collective on <A HREF="../Mat/Mat.html#Mat">Mat</A>
<P>
<H3><FONT COLOR="#CC3333">Input Parameters</FONT></H3>
<TABLE border="0" cellpadding="0" cellspacing="0">
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>mat </B></TD><TD>- the shell matrix
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>op </B></TD><TD>- the name of the operation
</TD></TR>
<TR><TD WIDTH=40></TD><TD ALIGN=LEFT VALIGN=TOP><B>f </B></TD><TD>- the function that provides the operation.
</TD></TR></TABLE>
<P>

<P>
<H3><FONT COLOR="#CC3333">Usage</FONT></H3>
<pre>
     extern <A HREF="../Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> usermult(<A HREF="../Mat/Mat.html#Mat">Mat</A>,<A HREF="../Vec/Vec.html#Vec">Vec</A>,<A HREF="../Vec/Vec.html#Vec">Vec</A>);
</pre>
<pre>
     ierr = <A HREF="../Mat/MatCreateShell.html#MatCreateShell">MatCreateShell</A>(<A HREF="../Sys/comm.html#comm">comm</A>,m,n,M,N,ctx,&amp;A);
</pre>
<pre>
     ierr = <A HREF="../Mat/MatShellSetOperation.html#MatShellSetOperation">MatShellSetOperation</A>(A,MATOP_MULT,(void(*)(void))usermult);
</pre>
<P>
<H3><FONT COLOR="#CC3333">Notes</FONT></H3>
See the file include/petscmat.h for a complete list of matrix
operations, which all have the form MATOP_&lt;OPERATION&gt;, where
&lt;OPERATION&gt; is the name (in all capital letters) of the
user interface routine (e.g., <A HREF="../Mat/MatMult.html#MatMult">MatMult</A>() -&gt; MATOP_MULT).
<P>
All user-provided functions should have the same calling
sequence as the usual matrix interface routines, since they
are intended to be accessed via the usual matrix interface
routines, e.g.,
<pre>
      <A HREF="../Mat/MatMult.html#MatMult">MatMult</A>(<A HREF="../Mat/Mat.html#Mat">Mat</A>,<A HREF="../Vec/Vec.html#Vec">Vec</A>,<A HREF="../Vec/Vec.html#Vec">Vec</A>) -&gt; usermult(<A HREF="../Mat/Mat.html#Mat">Mat</A>,<A HREF="../Vec/Vec.html#Vec">Vec</A>,<A HREF="../Vec/Vec.html#Vec">Vec</A>)
</pre>
<P>
Within each user-defined routine, the user should call
<A HREF="../Mat/MatShellGetContext.html#MatShellGetContext">MatShellGetContext</A>() to obtain the user-defined context that was
set by <A HREF="../Mat/MatCreateShell.html#MatCreateShell">MatCreateShell</A>().
<P>
<H3><FONT COLOR="#CC3333">Keywords</FONT></H3>
 matrix, shell, set, operation
<BR>
<P>
<H3><FONT COLOR="#CC3333">See Also</FONT></H3>
 <A HREF="../Mat/MatCreateShell.html#MatCreateShell">MatCreateShell</A>(), <A HREF="../Mat/MatShellGetContext.html#MatShellGetContext">MatShellGetContext</A>(), <A HREF="../Mat/MatShellGetOperation.html#MatShellGetOperation">MatShellGetOperation</A>(), <A HREF="../Mat/MatShellSetContext.html#MatShellSetContext">MatShellSetContext</A>()
<BR><P><B><P><B><FONT COLOR="#CC3333">Level:</FONT></B>advanced
<BR><FONT COLOR="#CC3333">Location:</FONT></B><A HREF="../../../src/mat/impls/shell/shell.c.html#MatShellSetOperation">src/mat/impls/shell/shell.c</A>
<BR><A HREF="./index.html">Index of all Mat routines</A>
<BR><A HREF="../../index.html">Table of Contents for all manual pages</A>
<BR><A HREF="../singleindex.html">Index of all manual pages</A>
<P><H3><FONT COLOR="#CC3333">Examples</FONT></H3>
<A HREF="../../../src/ksp/ksp/examples/tutorials/ex14f.F.html">src/ksp/ksp/examples/tutorials/ex14f.F.html</A><BR>
</BODY></HTML>
